build-scripts/emscripten-buildbot.sh
author Sam Lantinga
Tue, 10 Jan 2017 08:54:33 -0800
changeset 10806 36f40b8cc979
parent 10774 50a5917c297c
child 10958 92d837180433
permissions -rwxr-xr-x
Fixed bugs 2570, 3145, improved OpenGL ES context support on Windows and X11

Mark Callow

The attached patch does the following for the X11 and Windows platforms, the only ones where SDL attempts to use context_create_es_profile:

- Adds SDL_HINT_OPENGL_ES_DRIVER by which the application can
say to use the OpenGL ES driver & EGL rather than the Open GL
driver. (For bug #2570)
- Adds code to {WIN,X11}_GL_InitExtensions to determine the maximum
OpenGL ES version supported by the OpenGL driver (for bug #3145)
- Modifies the test that determines whether to use the OpenGL
driver or the real OpenGL ES driver to take into account the
hint, the requested and supported ES version and whether ES 1.X
is being requested. (For bug #2570 & bug #3145)
- Enables the testgles2 test for __WINDOWS__ and __LINUX__ and adds
the test to the VisualC projects.

With the fix in place I have run testdraw2, testgl and testgles2 without any issues and have run my own apps that use OpenGL, OpenGL ES 3 and OpenGL ES 1.1.
     1 #!/bin/bash
     2 
     3 if [ -z "$SDKDIR" ]; then
     4     SDKDIR="/emsdk_portable"
     5 fi
     6 
     7 ENVSCRIPT="$SDKDIR/emsdk_env.sh"
     8 if [ ! -f "$ENVSCRIPT" ]; then
     9    echo "ERROR: This script expects the Emscripten SDK to be in '$SDKDIR'." 1>&2
    10    echo "ERROR: Set the \$SDKDIR environment variable to override this." 1>&2
    11    exit 1
    12 fi
    13 
    14 TARBALL="$1"
    15 if [ -z $1 ]; then
    16     TARBALL=sdl-emscripten.tar.xz
    17 fi
    18 
    19 cd `dirname "$0"`
    20 cd ..
    21 SDLBASE=`pwd`
    22 
    23 if [ -z "$MAKE" ]; then
    24     OSTYPE=`uname -s`
    25     if [ "$OSTYPE" == "Linux" ]; then
    26         NCPU=`cat /proc/cpuinfo |grep vendor_id |wc -l`
    27         let NCPU=$NCPU+1
    28     elif [ "$OSTYPE" = "Darwin" ]; then
    29         NCPU=`sysctl -n hw.ncpu`
    30     elif [ "$OSTYPE" = "SunOS" ]; then
    31         NCPU=`/usr/sbin/psrinfo |wc -l |sed -e 's/^ *//g;s/ *$//g'`
    32     else
    33         NCPU=1
    34     fi
    35 
    36     if [ -z "$NCPU" ]; then
    37         NCPU=1
    38     elif [ "$NCPU" = "0" ]; then
    39         NCPU=1
    40     fi
    41 
    42     MAKE="make -j$NCPU"
    43 fi
    44 
    45 echo "\$MAKE is '$MAKE'"
    46 
    47 echo "Setting up Emscripten SDK environment..."
    48 source "$ENVSCRIPT"
    49 
    50 echo "Setting up..."
    51 set -x
    52 cd "$SDLBASE"
    53 rm -rf buildbot
    54 mkdir buildbot
    55 pushd buildbot
    56 
    57 echo "Configuring..."
    58 emconfigure ../configure --host=asmjs-unknown-emscripten --disable-assembly --disable-threads --enable-cpuinfo=false CFLAGS="-O2 -Wno-warn-absolute-paths -Wdeclaration-after-statement -Werror=declaration-after-statement" --prefix="$PWD/emscripten-sdl2-installed" || exit $?
    59 
    60 echo "Building..."
    61 emmake $MAKE || exit $?
    62 
    63 echo "Moving things around..."
    64 emmake $MAKE install || exit $?
    65 
    66 # Fix up a few things to a real install path
    67 perl -w -pi -e "s#$PWD/emscripten-sdl2-installed#/usr/local#g;" ./emscripten-sdl2-installed/lib/libSDL2.la ./emscripten-sdl2-installed/lib/pkgconfig/sdl2.pc ./emscripten-sdl2-installed/bin/sdl2-config
    68 mkdir -p ./usr
    69 mv ./emscripten-sdl2-installed ./usr/local
    70 popd
    71 tar -cJvvf $TARBALL -C buildbot usr
    72 rm -rf buildbot
    73 
    74 exit 0
    75 
    76 # end of emscripten-buildbot.sh ...
    77